/*
    PIP - Platform Independent Primitives
    Unit conversions
    Ivan Pelipenko peri4ko@yandex.ru

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "piunits_base.h"

#include "piliterals_string.h"

PIMap<int, PIUnits::Class::Internal::ClassBase *> PIUnits::Class::Internal::typeClasses;
PIVector<PIUnits::Class::Internal::ClassBase *> PIUnits::Class::Internal::allTypeClasses;
const PIString PIUnits::Class::Internal::unknown = "?"_a;


PIString PIUnits::className(int type) {
	auto * uc = Class::Internal::typeClasses.value(type);
	if (!uc) return Class::Internal::unknown;
	return uc->className();
}


PIString PIUnits::name(int type) {
	auto * uc = Class::Internal::typeClasses.value(type);
	if (!uc) return Class::Internal::unknown;
	return uc->name(type);
}


PIString PIUnits::unit(int type) {
	auto * uc = Class::Internal::typeClasses.value(type);
	if (!uc) return Class::Internal::unknown;
	return uc->unit(type);
}


PIVector<PIUnits::Class::Internal::ClassBase *> PIUnits::allClasses() {
	return Class::Internal::allTypeClasses;
}
